from.config import Config
from flask import Flask,request
from flask_sqlalchemy import SQLAlchemy
from flask_caching import Cache
from app.managers.entity_manager import EntityManager
from app.managers.cache_manager import CacheManager
from app.managers.file_manager import FileManager
from app.managers.image_manager import ImageManager
from app.helpers.logger_helper import init_logger
from flask_cors import CORS
from app.repositories.repository_provider import RepositoryProvider
def create_app():A=Flask(__name__);A.config.from_object(Config);return A
app=create_app()
init_logger(app)
CORS(app)
try:from flasgger import Swagger;swagger=Swagger(app)
except Exception:pass
cache=Cache(config=app.config)
cache.init_app(app)
cache_manager=CacheManager(cache,logger=app.logger)
db=SQLAlchemy(app)
em=EntityManager(db,cache_manager=cache_manager,logger=app.logger)
fm=FileManager(logger=app.logger)
entity_manager=EntityManager(db,cache_manager=cache_manager,logger=app.logger)
file_manager=FileManager(logger=app.logger)
image_manager=ImageManager(logger=app.logger)
repository_provider=RepositoryProvider(entity_manager)
@app.before_first_request
def before_first_request():from app.models import user_model,archive_model,category_model,customer_model,currency_model,wallet_model,document_model,comment_model,tag_model,mention_model,upload_model,setting_model;db.create_all()
from app.routes import action_routes
from app.routes import user_routes
from app.routes import archive_routes
from app.routes import category_routes
from app.routes import customer_routes
from app.routes import currency_routes
from app.routes import wallet_routes
from app.routes import document_routes
from app.routes import comment_routes
from app.routes import upload_routes
from app.routes import handshake_route
from app.routes import mention_routes
from app.routes import report_routes
from app.routes import setting_routes
from app.routes import backup_routes