from marshmallow import ValidationError
from app import app,file_manager
from app.helpers.error_helper import E
from PIL import Image as _Image
IMAGE_MIMES=['image/jpeg','image/gif','image/png','image/webp']
class Image:
	def __init__(A,image_base_path,image_base_url,image_rel_path=None,logger=None):A.image_base_path=image_base_path;A.image_base_url=image_base_url;A.image_rel_path=image_rel_path;A.logger=logger
	@property
	def image_abs_path(self):return file_manager.path_join(self.image_base_path,self.image_rel_path)
	@property
	def image_url(self):return self.image_base_url+self.image_rel_path
	def image_upload(A,file,image_size,image_quality):
		if file.mimetype not in IMAGE_MIMES:raise ValidationError({'user_file':[E.FILE_INVALID_MIME]})
		A.image_rel_path=file_manager.file_upload(file,A.image_base_path);A.image_resize(image_size,image_quality)
	def image_resize(D,image_size,image_quality):
		C=image_size
		try:A=_Image.open(D.image_abs_path)
		except Exception as B:app.logger.error('Could not open image. Image abs path: %s. Error: %s.'%(D.image_abs_path,str(B)));raise B
		with A:
			G=A.width/C[0];H=A.height/C[1];I=G if G<H else H
			try:A.thumbnail((A.width//I,A.height//I),_Image.ANTIALIAS)
			except Exception as B:app.logger.error('Could not resize image. Error: %s.'%str(B));raise B
			E=0
			if A.width>C[0]:E=(A.width-C[0])//2
			F=0
			if A.height>C[1]:F=(A.height-C[1])//2
			try:A=A.crop((E,F,E+C[0],F+C[1]))
			except Exception as B:app.logger.error('Could not crop image. Error: %s.'%str(B));raise B
			try:A.save(D.image_abs_path,image_quality=image_quality);app.logger.debug('Image saved. Image abs path: %s.'%D.image_abs_path)
			except Exception as B:app.logger.error('Could not save image. Image abs path: %s. Error: %s.'%(D.image_abs_path,str(B)));raise B
	def image_delete(A):file_manager.file_delete(A.image_abs_path)