_I='offset'
_H='limit'
_G='order'
_F='id'
_E=False
_D=None
_C=True
_B='order_by'
_A='subquery'
import time
from sqlalchemy import asc,desc,text
from sqlalchemy.sql import func,exists
RESERVED_KEYS=[_A,_B,_G,_H,_I]
class EntityManager:
	def __init__(A,db,cache_manager=_D,logger=_D):A.db=db;A.cache_manager=cache_manager;A.logger=logger
	def insert(A,obj,use_cache=_C,auto_commit=_E):
		B=obj
		try:
			if A.logger:D=time.time()
			A.lock(B.__class__);A.db.session.add(B);A.db.session.flush()
			if auto_commit:A.commit()
			if A.logger:C=time.time()-D;A.logger.debug('Entity is inserted in database. Elapsed time: %s. Entity: %s.'%(str(C),str(B.__dict__)))
		except Exception as E:
			if A.logger:C=time.time()-D;A.logger.error('Error inserting entity in database. Elapsed time: %s. Entity: %s. Error: %s.'%(str(C),str(B.__dict__),str(E)))
			raise E
		if use_cache and A.cache_manager:A.cache_manager.set(B)
	def select(A,cls,use_cache=_C,**C):
		F=use_cache;D=cls;B=_D
		if F and A.cache_manager and _F in C and len(C)==1:B=A.cache_manager.get(D,C[_F])
		if not B:
			try:
				if A.logger:G=time.time()
				B=D.query.filter(*A._extract_clauses([A._add_clause(D,B,C)for(B,C)in C.items()])).first()
				if A.logger:
					E=time.time()-G
					if B:A.logger.debug('Entity selected from database. Elapsed time: %s. Entity: %s.'%(str(E),str(B.__dict__)))
					else:A.logger.debug('Entity not found in database. Elapsed time: %s. Class: %s. Kwargs: %s.'%(str(E),str(D.__dict__),str(C)))
			except Exception as H:
				if A.logger:E=time.time()-G;A.logger.error('Error selecting entity from database.  Elapsed time: %s. Class: %s. Kwargs: %s. Exception: %s.'%(str(E),str(D.__dict__),str(C),str(H)))
				raise H
		if F and A.cache_manager and B:A.cache_manager.set(B)
		return B
	def update(A,obj,use_cache=_C,auto_commit=_E):
		B=obj
		try:
			if A.logger:D=time.time()
			A.db.session.merge(B);A.db.session.flush()
			if auto_commit:A.commit()
			if A.logger:C=time.time()-D;A.logger.debug('Entity updated in database. Elapsed time: %s. Entity: %s.'%(str(C),str(B.__dict__)))
		except Exception as E:
			if A.logger:C=time.time()-D;A.logger.error('Error updating entity in database. Elapsed time: %s. Entity: %s. Exception: %s.'%(str(C),str(B.__dict__),str(E)))
			raise E
		if use_cache and A.cache_manager:A.cache_manager.set(B)
	def delete(A,obj,use_cache=_C,auto_commit=_E):
		B=obj
		try:
			if A.logger:D=time.time()
			A.db.session.delete(B);A.db.session.flush()
			if auto_commit:A.commit()
			if A.logger:C=time.time()-D;A.logger.debug('Entity deleted from database. Elapsed time: %s. Entity: %s.'%(str(C),str(B.__dict__)))
		except Exception as E:
			if A.logger:C=time.time()-D;A.logger.error('Error deleting entity from database. Elapsed time: %s. Entity: %s. Exception: %s.'%(str(C),str(B.__dict__),str(E)))
			raise E
		if use_cache and A.cache_manager:A.cache_manager.delete(B.__class__,B.id)
	def select_some(C,cls,use_cache=_C,**B):
		D=cls
		try:
			if C.logger:G=time.time()
			A=D.query.filter(*C._extract_clauses([C._add_clause(D,A,B)for(A,B)in B.items()if A not in RESERVED_KEYS]))
			if _A in B:I=C._get_subquery(**B[_A]);A=A.filter(D.id.in_(I))
			if _B in B and B[_G]=='asc':A=A.order_by(asc(B[_B]))
			elif _B in B and B[_G]=='desc':A=A.order_by(desc(B[_B]))
			else:A=A.order_by(asc(_F))
			if _H in B:A=A.limit(B[_H])
			else:A=A.limit(_D)
			if _I in B:A=A.offset(B[_I])
			else:A=A.offset(0)
			E=A.all()
			if C.logger:F=time.time()-G;C.logger.debug('Entities selected from database. Elapsed time: %s. Entities: %s.'%(str(F),str([A.__dict__ for A in E])))
		except Exception as H:
			if C.logger:F=time.time()-G;C.logger.error('Error selecting entities from database. Elapsed time: %s. Class: %s. Kwargs: %s. Exception: %s.'%(str(F),str(D.__dict__),str(B),str(H)))
			raise H
		if use_cache and C.cache_manager:
			for J in E:C.cache_manager.set(J)
		return E
	def count(A,cls,**C):
		B=cls
		try:
			if A.logger:F=time.time()
			D=A.db.session.query(func.count(getattr(B,_F))).filter(*A._extract_clauses([A._add_clause(B,C,D)for(C,D)in C.items()if C not in RESERVED_KEYS]))
			if _A in C:H=A._get_subquery(**C[_A]);D=D.filter(B.id.in_(H))
			I=D.one()[0]
			if A.logger:E=time.time()-F;A.logger.debug('Entities counted. Elapsed time: %s. Class: %s. Kwargs: %s.'%(str(E),str(B.__dict__),str(C)))
		except Exception as G:
			if A.logger:E=time.time()-F;A.logger.error('Error counting entities. Elapsed time: %s. Class: %s. Kwargs: %s. Exception: %s.'%(str(E),str(B.__dict__),str(C),str(G)))
			raise G
		return I
	def sum(A,cls,column,**C):
		D=column;B=cls
		try:
			if A.logger:G=time.time()
			E=A.db.session.query(func.sum(getattr(B,D))).filter(*A._extract_clauses([A._add_clause(B,C,D)for(C,D)in C.items()if C not in RESERVED_KEYS]))
			if _A in C:I=A._get_subquery(**C[_A]);E=E.filter(B.id.in_(I))
			J=E.one()[0]or 0
			if A.logger:F=time.time()-G;A.logger.debug('Column summed. Elapsed time: %s. Class: %s. Column: %s. Kwargs: %s.'%(str(F),str(B.__dict__),D,str(C)))
		except Exception as H:
			if A.logger:F=time.time()-G;A.logger.error('Error summing column. Elapsed time: %s. Class: %s. Column: %s. Kwargs: %s. Exception: %s.'%(str(F),str(B.__dict__),D,str(C),str(H)))
			raise H
		return J
	def exists(A,cls,**C):
		B=cls
		try:
			if A.logger:E=time.time()
			G=A.db.session.query(exists().where(*A._extract_clauses([A._add_clause(B,C,D)for(C,D)in C.items()]))).scalar()
			if A.logger:D=time.time()-E;A.logger.debug('Exist checked. Elapsed time: %s. Class: %s. Kwargs: %s.'%(str(D),str(B.__dict__),str(C)))
		except Exception as F:
			if A.logger:D=time.time()-E;A.logger.error('Error exist checking. Elapsed time: %s. Class %s. Kwargs %s. Exception: %s.'%(str(D),str(B.__dict__),str(C),str(F)))
			raise F
		return G
	def query(A,sql,auto_commit=_E):
		B=sql
		try:
			if A.logger:D=time.time()
			F=A.db.engine.execute(text(B))
			if auto_commit:A.commit()
			if A.logger:C=time.time()-D;A.logger.debug('Query has been executed. Elapsed time: %s. Query: %s.'%(str(C),B))
		except Exception as E:
			if A.logger:C=time.time()-D;A.logger.error('Could not execute query. Elapsed time: %s. Query: %s. Exception: %s.'%(str(C),B,str(E)))
			raise E
		return F
	def lock(A,cls):
		B=cls
		try:
			if A.logger:D=time.time()
			A.db.session.execute('LOCK TABLE %s IN ACCESS EXCLUSIVE MODE;'%B.__tablename__)
			if A.logger:C=time.time()-D;A.logger.debug('Table locked. Elapsed time: %s. Class: %s.'%(str(C),str(B.__dict__)))
		except Exception as E:
			if A.logger:C=time.time()-D;A.logger.error('Error locking table. Elapsed time: %s. Class: %s. Exception: %s.'%(str(C),str(B.__dict__),str(E)))
			raise E
	def commit(A):
		try:
			if A.logger:C=time.time()
			A.db.session.commit()
			if A.logger:B=time.time()-C;A.logger.debug('Transaction committed. Elapsed time: %s.'%str(B))
		except Exception as D:
			if A.logger:B=time.time()-C;A.logger.error('Error committing transaction. Elapsed time: %s. Exception: %s.'%(str(B),str(D)))
			raise D
	def rollback(A):
		try:
			if A.logger:C=time.time()
			A.db.session.rollback()
			if A.logger:B=time.time()-C;A.logger.debug('Transaction rollbacked. Elapsed time: %s.'%str(B))
		except Exception as D:
			if A.logger:B=time.time()-C;A.logger.error('Error rollbacking transaction. Elapsed time: %s. Exception: %s.'%(str(B),str(D)))
			raise D
	def count_tables(A):B=A.query("select count(*) from information_schema.tables where table_schema = 'public'");return next(B).count
	def _add_clause(D,cls,k,v):
		B=cls
		if isinstance(v,list):return getattr(B,k).in_(v)
		elif isinstance(v,dict):
			C=[]
			for A in v:
				if A=='=':C.append(getattr(B,k)==v[A])
				elif A=='!=':C.append(getattr(B,k)!=v[A])
				elif A=='>':C.append(getattr(B,k)>v[A])
				elif A=='>=':C.append(getattr(B,k)>=v[A])
				elif A=='<':C.append(getattr(B,k)<v[A])
				elif A=='<=':C.append(getattr(B,k)<=v[A])
			return C
		elif str(v).startswith('%')and str(v).endswith('%'):return getattr(B,k).ilike(v)
		else:return getattr(B,k)==v
	def _extract_clauses(C,clauses):
		A=[]
		for B in clauses:
			if isinstance(B,list):A.extend(B)
			else:A.append(B)
		return A
	def _get_subquery(A,**B):return A.db.session.query(B['foreign_key']).filter(*A._extract_clauses([A._add_clause(B['subquery_cls'],C,D)for(C,D)in B['subquery_kwargs'].items()])).subquery()