_L='wallet_id'
_K='customer_id'
_J='category_id'
_I='archive_id'
_H='document_sum'
_G='closed_date'
_F='created_date'
_E='document_name'
_D='document_status'
_C=False
_B=None
_A=True
import time
from enum import Enum
from app import db,entity_manager
from app.models.extended_model import ExtendedModel
from app.models.user_model import UserModel
from app.models.archive_model import ArchiveModel
from app.models.category_model import CategoryModel
from app.models.customer_model import CustomerModel
from app.models.wallet_model import WalletModel
from app.models.tag_model import TagModel
from app.models.mention_model import MentionModel
from app.models.upload_model import UploadModel
from decimal import Decimal
from app.config import Config
DOCUMENT_COLUMNS_ORDER_BY=['id',_F,_G,_D,_H,_E]
DOCUMENT_COLUMNS_EQUAL=[_D,_I,_J,_K,_L]
DOCUMENT_COLUMNS_LIKE=[_E]
class DocumentStatus(Enum):draft=0;todo=1;done=2
class DocumentModel(ExtendedModel):
	__tablename__='documents';closed_date=db.Column(db.BigInteger(),nullable=_C,default=lambda:int(time.time()));user_id=db.Column(db.BigInteger,db.ForeignKey('users.id'),index=_A,nullable=_C);wallet_id=db.Column(db.BigInteger,db.ForeignKey('wallets.id'),nullable=_C,index=_A);category_id=db.Column(db.BigInteger,db.ForeignKey('categories.id'),nullable=_A,default=_B,index=_A);customer_id=db.Column(db.BigInteger,db.ForeignKey('customers.id'),nullable=_A,default=_B,index=_A);archive_id=db.Column(db.BigInteger,db.ForeignKey('archives.id'),nullable=_A,default=_B,index=_A);document_status=db.Column(db.Enum(DocumentStatus),nullable=_C,index=_A);document_name=db.Column(db.String(128),nullable=_C,index=_A);document_content=db.Column(db.Text,nullable=_A);document_sum=db.Column(db.Numeric,nullable=_C,default=0);comments_count=db.Column(db.BigInteger,nullable=_C,default=0);uploads_count=db.Column(db.BigInteger,nullable=_C,default=0);uploads_size=db.Column(db.BigInteger,nullable=_C,default=0);qrcode_rel_path=db.Column(db.String(255),nullable=_A)
	def __init__(A,closed_date,user_id,wallet_id,document_status,document_name,document_content=_B,document_sum=Decimal('0'),category_id=_B,customer_id=_B,archive_id=_B):A.closed_date=closed_date;A.user_id=user_id;A.wallet_id=wallet_id;A.category_id=category_id;A.customer_id=customer_id;A.archive_id=archive_id;A.document_status=document_status;A.document_name=document_name;A.document_content=document_content;A.document_sum=document_sum;A.comments_count=0;A.uploads_count=0;A.uploads_size=0
	def to_dict(A,join=_B):
		N='archive';M='customer';L='category';K='wallet';J='user';B=join
		if not A.id:return{}
		if not B:B=[]
		C={'id':A.id,_F:A.created_date,'updated_date':A.updated_date,_G:A.closed_date,'user_id':A.user_id,_L:A.wallet_id,_J:A.category_id,_K:A.customer_id,_I:A.archive_id,_D:A.document_status.name,_E:A.document_name,'document_content':A.document_content,_H:A.document_sum,'comments_count':A.comments_count,'uploads_count':A.uploads_count,'uploads_size':A.uploads_size,'qrcode_image':Config.QRCODE_BASE_URL+A.qrcode_rel_path if A.qrcode_rel_path else''}
		if J in B:O=entity_manager.select(UserModel,id=A.user_id);C[J]=O.to_dict()
		if K in B:P=entity_manager.select(WalletModel,id=A.wallet_id);C[K]=P.to_dict(join=['currency'])
		if L in B:D=entity_manager.select(CategoryModel,id=A.category_id)if A.category_id else _B;C[L]=D.to_dict()if D else{}
		if M in B:E=entity_manager.select(CustomerModel,id=A.customer_id)if A.customer_id else _B;C[M]=E.to_dict()if E else{}
		if N in B:F=entity_manager.select(ArchiveModel,id=A.archive_id)if A.archive_id else _B;C[N]=F.to_dict()if F else{}
		if'tags'in B:Q=entity_manager.select_some(TagModel,document_id=A.id);C['document_tags']=[A.document_tag for A in Q]
		if'uploads'in B:R=entity_manager.select_some(UploadModel,document_id=A.id);C['document_uploads']=[A.to_dict()for A in R]
		if'mentions'in B:
			G=entity_manager.select_some(MentionModel,document_id=A.id);H={}
			if G:
				for S in G:I=entity_manager.select(UserModel,id=S.user_id);H[I.user_login]=I.id
			C['document_mentions']=H
		return C