_F='created_date'
_E='user_name'
_D='user_login'
_C='user_role'
_B=True
_A=False
from enum import Enum
from app import db
from app.models.extended_model import ExtendedModel
from app.helpers.fernet_helper import FernetHelper
from app.helpers.hash_helper import Hash
USER_PASS_ATTEMPTS_LIMIT=10
USER_PASS_SUSPEND_TIME=30
USER_COLUMNS_ORDER_BY=['id',_F,_C,_D,_E]
USER_COLUMNS_EQUAL=[_C]
USER_COLUMNS_LIKE=[_D,_E]
USER_IMAGE_BASE_PATH='/docu/images/users/'
USER_IMAGE_BASE_URL='http://localhost/images/users/'
USER_IMAGE_SIZE=640,480
USER_IMAGE_QUALITY=90
class UserRole(Enum):blank=0;reader=1;writer=2;editor=3;admin=4
class UserModel(ExtendedModel):
	__tablename__='users';suspended_date=db.Column(db.BigInteger,nullable=_A,default=0);user_role=db.Column(db.Enum(UserRole),nullable=_A,default=UserRole.blank);user_login=db.Column(db.String(40),nullable=_A,unique=_B,index=_B);pass_hash=db.Column(db.String(128),nullable=_A,index=_B);pass_attempts=db.Column(db.SmallInteger(),nullable=_A,default=0);user_name=db.Column(db.String(40),nullable=_A,index=_B);user_job=db.Column(db.String(40),nullable=_B);user_contacts=db.Column(db.String(255),nullable=_B);user_summary=db.Column(db.String(255),nullable=_B);jti_encrypted=db.Column(db.String(255),nullable=_A);mfa_key_encrypted=db.Column(db.String(255),nullable=_A);image_rel_path=db.Column(db.String(255),nullable=_B)
	def __init__(A,user_login,user_pass,user_name):C=user_pass;B=None;A.suspended_date=0;A.user_role=UserRole.blank;A.user_login=user_login;A.user_pass=C;A.pass_hash=Hash.get_hash(C);A.pass_attempts=0;A.user_name=user_name;A.user_job=B;A.user_contacts=B;A.user_summary=B;A.jti_encrypted=B;A.mfa_key_encrypted=B;A.mfa_image=B;A.image_rel_path=B
	def __setattr__(C,key,value):
		D='user_pass';B=key;A=value
		if B==D:super().__setattr__(D,A);super().__setattr__('pass_hash',Hash.get_hash(A))
		elif B=='jti':C.jti_encrypted=FernetHelper.encrypt(A)
		elif B=='mfa_key':C.mfa_key_encrypted=FernetHelper.encrypt(A)
		else:super().__setattr__(B,A)
	@property
	def jti(self):return FernetHelper.decrypt(self.jti_encrypted)
	@property
	def mfa_key(self):return FernetHelper.decrypt(self.mfa_key_encrypted)
	@property
	def can_admin(self):return self.user_role==UserRole.admin
	@property
	def can_edit(self):return self.user_role in[UserRole.admin,UserRole.editor]
	@property
	def can_write(self):return self.user_role in[UserRole.admin,UserRole.editor,UserRole.writer]
	@property
	def can_read(self):return self.user_role in[UserRole.admin,UserRole.editor,UserRole.writer,UserRole.reader]
	def to_dict(A):
		if not A.id:return{}
		return{'id':A.id,_F:A.created_date,'updated_date':A.updated_date,_D:A.user_login,_C:A.user_role.name,_E:A.user_name,'user_job':A.user_job or'','user_contacts':A.user_contacts or'','user_summary':A.user_summary or'','user_image':USER_IMAGE_BASE_URL+A.image_rel_path if A.image_rel_path else''}